;;; wege.scm
;;; stellt die Funktionen fuer die Verwaltung der Wege bereit

(load "gallenbacher-graph-kanten.scm")
; Verwendet wird davon die Kantenliste *kanten*
; und die Zugriffsfunktion (nachfolge-kanten <aktuelle-stadt> <kanten>)

; Wege sind Listen aus der Laenge und den besuchten Knoten (rueckwaerts)
; Muster: (60 X B I)

;;; ===== alle-nachfolge-wege =====
; gibt zum aktuellen Weg alle Wege zurueck, die sich aus den
; Nachfolgekanten ergeben.
(define
  (alle-nachfolge-wege weg kanten)
  (define
    (alle-intern die-nachfolger neue-wege)
    (cond
      ((null? die-nachfolger) neue-wege)
      ((member (second (first die-nachfolger)) weg) ; nicht zurueck
       (alle-intern (rest die-nachfolger) neue-wege))
      (else
       (alle-intern
        (rest die-nachfolger)
        (cons
         (neuer-weg weg (first die-nachfolger))
         neue-wege)))
    ))
(alle-intern
 (nachfolge-kanten
  (second weg) ; der aktuelle Knoten steht nach der Laenge im weg
  kanten)
 '()))


;;; ===== Hilfsfunktion neuer-weg =====
; Gibt zu einem Weg und zu einer Kante den verlaengerten Weg zurueck.
(define
  (neuer-weg weg kante)
  (cons
   (+ (third kante) (first weg)) ; neue Weglaenge
   (cons
    (second kante) ; Zielort der Kante vorn einbauen
    (rest weg))))
;Tests:
; (neuer-weg '(34 B I) '(B X 26))
; -> '(60 X B I)

;;; ===== alle-nachfolge-wege =====
; Tests:
; (alle-nachfolge-wege '(22 N A) *kanten*)
; -> '((52 Z N A) (51 X N A) (42 D N A))
